private import common;
private import obj;
private import objspecs;
private import game;
private import opengl;
private import texture;
private import mygl;
private import rainbow_color;
private import sound_phase;
private import rc;
private import sino;

class BgLattice : Obj {
    mixin HasAbsolutePush;

public:
    this() {
        fw = cast(float)(Game.obj.fieldWidth);
        fh = cast(float)(Game.obj.fieldHeight);
        xs = fw / NUM;
        ys = fh / NUM;
        turn = 0;

        bg1 = Sino.rc.getInt(`bg1`);
        bg2 = Sino.rc.getInt(`bg2`);
    }

    override void move() {
        turn++;
    }

    override void draw() {
        float t = SoundPhase.phase;

        if (bg1) {
            glLineWidth(2);

            glBegin(GL_LINES);

            if (bg1 == 1) {
                glColor4f(0.3, 0.7, 0.3, 0.3);

                float fs = 2840*4;
                for (int i = 1; i < NUM; i++) {
                    float a = 2*PI*i/NUM + (t+60)*0.0001;
                    float c = fs*cos(a);
                    float s = fs*sin(a);
                    myglClippedLine(-fw, -fh, c, s);
                    myglClippedLine(fw+fw, -fh, c, s);
                    myglClippedLine(-fw, fh+fh, c, s);
                    myglClippedLine(fw+fw, fh+fh, c, s);
                    a = 2*PI*i/NUM + t*0.0001436332;
                    c = fs*cos(a);
                    s = fs*sin(a);
                    myglClippedLine(-fw, -fh, c, s);
                    myglClippedLine(fw+fw, -fh, c, s);
                    myglClippedLine(-fw, fh+fh, c, s);
                    myglClippedLine(fw+fw, fh+fh, c, s);
                }
            }
            else {
                glColor4f(0.3, 0.7, 0.3, 0.15);
                for (int i = 1; i < NUM; i+=2) {
                    myglClippedLine(-fw, fh*i/NUM, fw+fw, fh*i/NUM);
                    myglClippedLine(fw*i/NUM, -fh, fw*i/NUM+0.001, fh+fh);
                }
            }

            glEnd();
        }

        if (bg2) {
            pushMatrix();

            glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
            float[4] texcoord = Texture.prepare(TextureID.TEX_PSYNO);
            float c = cos(t*0.000736332)*0.3;
            float s = sin(t*0.000436332)*0.3;
            glColor4f(1, 1, 1, 0.4);
            glBegin(GL_QUADS);
            glTexCoord2f(texcoord[0]+c, texcoord[1]+s);
            glVertex2f(0, 0);
            glTexCoord2f(texcoord[2]+c, texcoord[1]-s);
            glVertex2f(0, fh);
            glTexCoord2f(texcoord[2]-c, texcoord[3]-s);
            glVertex2f(fw, fh);
            glTexCoord2f(texcoord[0]-c, texcoord[3]+s);
            glVertex2f(fw, 0);
            glEnd();
            glPopMatrix();

            glBlendFunc(GL_SRC_ALPHA, GL_ONE);
            glDisable(GL_TEXTURE_2D);
        }

    }

private:
    static const int NUM = 80;
    float fw, fh;
    float xs, ys;

    int turn;

    int bg1, bg2;
}
