import opengl;
import openglu;
private import game;

void myglCircle(float x, float y, float r, float[] xs, float[] ys) {
    glBegin(GL_TRIANGLE_FAN);

    glVertex3f(0, 0, 0);

    for (int i = 1; i < xs.length; i++) {
        glVertex3f(x+xs[i-1]*r, y+ys[i-1]*r, 0);
        glVertex3f(x+xs[i]*r, y+ys[i]*r, 0);
    }

    glEnd();
}

void myglCircle8(float x, float y, float r) {
    static float[] xs =
        [ 0, 1.4, 2, 1.4, 0, -1.4, -2, -1.4, 0 ];
    static float[] ys =
        [ 2, 1.4, 0, -1.4, -2, -1.4, 0, 1.4, 2 ];

    myglCircle(x, y, r, xs, ys);
}

void myglCircle16(float x, float y, float r) {
    static float[] xs =
        [ 0, 0.77, 1.4, 1.85, 2, 1.85, 1.4, 0.77, 0,
          -0.77, -1.4, -1.85, -2, -1.85, -1.4, -0.77, 0 ];
    static float[] ys =
        [ 2, 1.85, 1.4, 0.77, 0, -0.77, -1.4, -1.85, -2,
          -1.85, -1.4, -0.77, 0, 0.77, 1.4, 1.85,  2 ];

    myglCircle(x, y, r, xs, ys);
}
void myglCircle(float r, float[] xs, float[] ys) {
    myglCircle(0, 0, r, xs, ys);
}

void myglCircle8(float r) {
    myglCircle8(0, 0, r);
}

void myglCircle16(float r) {
    myglCircle16(0, 0, r);
}

void myglClippedLine(float x1, float y1, float x2, float y2) {
    myglClippedLine(x1, y1, x2, y2, 0);
}
void myglClippedLine(float x1, float y1, float x2, float y2, float z) {
    myglClippedLine(x1, y1, x2, y2, z, z);
}
void myglClippedLine(float x1, float y1, float x2, float y2,
                     float z1, float z2) {
    Game.obj.convPos(x1, y1);
    Game.obj.convPos(x2, y2);
    float ox1, ox2;
    if (x1 > x2) {
        ox1 = x2;
        ox2 = x1;
    }
    else {
        ox1 = x1;
        ox2 = x2;
    }
    float a = (y2 - y1) / (x2 - x1);
    float b = y1 - a * x1;

    void clip(inout float x, inout float y) {
        if (x < 0) {
            x = 0;
            y = b;
        }
        else if (x > Game.obj.gameWidth) {
            x = Game.obj.gameWidth;
            y = a * x + b;
        }
        if (y < 0) {
            y = 0;
            x = -b / a;
        }
        else if (y > Game.obj.gameHeight) {
            y = Game.obj.gameHeight;
            x = (y - b) / a;
        }
    }
    clip(x1, y1);
    clip(x2, y2);

    if (ox1 >= x1 || ox2 <= x2) return;
    if (y1 == y2 && (y1 == 0 || y1 == Game.obj.gameHeight)) return;

    glVertex3f(x1, y1, z1);
    glVertex3f(x2, y2, z2);
}

// 3, 4 Τ clip
void myglClippedLine2(float x1, float y1, float x2, float y2) {
    myglClippedLine2(x1, y1, x2, y2, 0);
}
void myglClippedLine2(float x1, float y1, float x2, float y2, float z) {
    myglClippedLine2(x1, y1, x2, y2, z, z);
}
void myglClippedLine2(float x1, float y1, float x2, float y2,
                      float z1, float z2) {
    Game.obj.convPos(x1, y1);
    Game.obj.convPos(x2, y2);

    float a = (y2 - y1) / (x2 - x1);
    float b = y1 - a * x1;

    void clip(inout float x, inout float y) {
        if (x < 0) {
            x = 0;
            y = b;
        }
        else if (x > Game.obj.gameWidth) {
            x = Game.obj.gameWidth;
            y = a * x + b;
        }
        if (y < 0) {
            y = 0;
            x = -b / a;
        }
        else if (y > Game.obj.gameHeight) {
            y = Game.obj.gameHeight;
            x = (y - b) / a;
        }
    }
    clip(x2, y2);

    glVertex3f(x1, y1, z1);
    glVertex3f(x2, y2, z2);
}

