template HasLife() {
    override bit alive() { return life_ > 0; }
    override void die() { life_ = 0; }
    float life_;
}

template HasRelativePush() {
    void pushMatrix() {
        pushMatrix(0);
    }
    void pushMatrix(float x, float y) {
        pushMatrix(x, y, 0);
    }
    void pushMatrix(float z) {
        pushMatrix(x_, y_, z);
    }
    void pushMatrix(float x, float y, float z) {
        Game.obj.convPos(x, y);
        glPushMatrix();
        glTranslatef(x, y, z);
    }
}

template HasAbsolutePush() {
    void pushMatrix() {
        pushMatrix(0);
    }
    void pushMatrix(float z) {
        float x = 0;
        float y = 0;
        Game.obj.convPos(x, y);
        glPushMatrix();
        glTranslatef(x, y, z);
    }
}

template HasClipping() {
    bool isInsideGame() {
        if (x_ < size_) return false;
        else if (x_ > Game.obj.fieldWidth - size_) return false;
        if (y_ < size_) return false;
        else if (y_ > Game.obj.fieldHeight - size_) return false;
        return true;
    }
    void clipPos() {
        if (x_ < size_) x_ = size_;
        else if (x_ > Game.obj.fieldWidth - size_)
            x_ = Game.obj.fieldWidth - size_;
        if (y_ < size_) y_ = size_;
        else if (y_ > Game.obj.fieldHeight - size_)
            y_ = Game.obj.fieldHeight - size_;
    }
}
