private import objmgr;
private import effect;
private import common;
private import obj;
private import mygl;

class ResultDisplay : Obj {
    this(char[] title) {
        msgs_ = new ObjMgr!(StringEffect)("msgs");
        title_ = title;
    }

    override void move() {
        turn++;
        msgs_.move();
    }

    override void draw() {
        msgs_.draw();

        glDisable(GL_TEXTURE_2D);
        glColor4f(1, 1, 1, 0.3);
        glBegin(GL_LINES);

        float ratio = 0.000015;
        if (scoreStat.length > 0 && scoreStat[length-1] > 30000000) {
            ratio = 440.0 / scoreStat[length-1];
        }

        for (int i = 1; i < scoreStat.length; i++) {
            if (i > turn) break;

            glVertex2f((i-1)*2, 450-scoreStat[i-1]*ratio);
            glVertex2f(i*2, 450-scoreStat[i]*ratio);

            if (i == endTurn/62) {
                glVertex2f(i*2, 450);
                glVertex2f(i*2, 440);
            }
        }
        glEnd();
    }

    void init() {
        msgs_.objs.length = 0;

        int[] scores;
        scores ~= gameScore;
        scores ~= turnScore;
        scores ~= clearScore;
        scores ~= leftScore;
        scores ~= nomissScore;
//        scores ~= gameScore+turnScore+clearScore+leftScore+nomissScore;

        char[][] scoreDescs;
        scoreDescs ~= "Stage Score";
        scoreDescs ~= "Turn Score";
        scoreDescs ~= "Clear Score";
        scoreDescs ~= "Left Score";
        scoreDescs ~= "No Miss Score";
//        scoreDescs ~= "Score";

        float xl = 130;
        float xr = 350;
        float yo = 100;
        float yp = 50;
        float ya = 20;
        int to = 30;
        int tp = 30;
        int ta = 10;

        msgs_.add((new StringEffect(
                       xl, yo-yp, title_,
                       16, 20, 1,1,1, 0, 0)).center);

        for (int i = 0; i < scores.length; i++) {
            msgs_.add(new StringEffect(
                          xl, yo+i*yp, scoreDescs[i],
                          14, 18, 1,1,1, 0, -i*tp-to));
            msgs_.add((new StringEffect(
                           xr, yo+i*yp+ya,
                           tostr(scores[i]), 14, 18, 1,1,1, 0,
                           -i*tp-ta-to)).right);
        }
        msgs_.add(new StringEffect(
                      xl, yo+scores.length*yp+ya, "Score",
                      14, 18, 1,1,1, 0, -scores.length*tp-ta-to));
        msgs_.add((new StringEffect(
                       xr, yo+scores.length*yp+ya*2,
                       tostr(allScore), 14, 18, 1,1,1, 0,
                       -scores.length*tp-ta*2-to)).right);

        turn = 0;
    }

public:
    int gameScore;
    int turnScore;
    int clearScore;
    int leftScore;
    int nomissScore;
    int allScore;

    int endTurn;
    int[] scoreStat;

    int turn;

    char[] title_;

    bool hasReplayInfo;
    char[] mode;
    char[] pversion;
    char[] name;
    char[] date;

private:
    ObjMgr!(StringEffect) msgs_;
}
