private import std.math;

private import SDL;

private import charactor;
private import log;
private import mymath;
private import mygl;
private import objspecs;
private import game;
private import texture;

class Shot : public Charactor {
    mixin HasRelativePush;
    mixin HasClipping;

public:
     this(float x, float y, float sx, float sy, float[3] col0) {
        x_ = x;
        y_ = y;
        sx_ = sx;
        sy_ = sy;
        alive_ = true;
        col[] = col0;
    }

    this(float x, float y, float sx, float sy,
         float a, float s, float[3] col0)
    {
        a_ = a;
        s_ = s;

        this(x, y, sx, sy, col0);
    }

    void vanish() {
        alive_ = false;
    }

    override void move() {
        super.move();

        if (!Game.obj.isInside(x_, y_, 5)) alive_ = false;
        else if (!isInsideGame()) alive_ = false;
    }

    override void draw() {
        if (!alive_) return;

        pushMatrix();

        GLfloat[] texcoord = Texture.prepare(TextureID.TEX_PARTICLE);

        glColor4f(col[0], col[1], col[2], 1.0);

//        float tx = 32 + ((vx > 0) ? 0 : -vx) * 10;
//        float ty = 32 + ((vy > 0) ? 0 : -vy) * 10;
        float tx = 10;
        float ty = 10;
        glBegin(GL_QUADS);
        glTexCoord2f(texcoord[0], texcoord[1]);
        glVertex2f(-tx, -ty);
        glTexCoord2f(texcoord[0], texcoord[3]);
        glVertex2f(-tx, ty);
        glTexCoord2f(texcoord[2], texcoord[3]);
        glVertex2f(tx, ty);
        glTexCoord2f(texcoord[2], texcoord[1]);
        glVertex2f(tx, -ty);
        glEnd();

        glDisable(GL_TEXTURE_2D);

        glPopMatrix();
    }

    float[3] col;

}
